//<c>   Copyright 1995-1999 by Gerry J. Danen; all rights reserved.

//<t>   Remove empty lines

//      This program removes null lines.  Other lines have trailing spaces
//      trimmed.
//
//      Usage:  REMSPACE file_in file_out
//
//      Full pathnames are supported for the filenames.

#include"gd_tools.h"


#define pgVERS_ "V2.00"
#define pgTITL_ "Remove Empty Lines"
#define pgCOPR_ "1995"


FILE    *iFh, *oFh ;
char    work[10001], *w ;
long    lines = 0 ;


void    strip_sp( char *string )
{
    char *last ;

    last = string + strlen(string) ;            //  get to end of string
    while ( ((*last == EOS) || (isspace(*last))) && (last >= string) )
    {
        *last-- = EOS ;
    }
}


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 3 )
    {
        fprintf( stderr, "\n\nUsage:  %s file_in file_out\n\n", get_global_program_name() );
        exit( 1 );
    }

    if ( ! ( iFh = fopen( argv[1], "r" ) ) )
    {
        fprintf( stderr, "\n\nFile %s not found\a\n", argv[1] );
        exit( 2 );
    }
    oFh = fl_create_or_replace_tty( oFh, argv[2], "w", YES, YES );

    fprintf( stderr, "\nRemSpace: %s -> %s ...", argv[1], argv[2] );
    for (;;)
    {
        w = fgets( work, (sizeof(work)-1), iFh );
        if ( w )
        {
            if ( work[strlen(work)-1] == '\n' || work[strlen(work)-1] == '\r' )
                work[strlen(work)-1] = ' ';
            strip_sp( work );
            if ( strlen(work) )
            {
                fprintf( oFh, "%s\n", work );
                lines += 1 ;
            }
        }
        if ( feof(iFh) )
        {
            fclose( iFh );
            fclose( oFh );
            fprintf( stderr, " %ld lines\n", lines );
            exit( 0 );
        }
    }
}
